/////////////////////////////////////////////////////////////////////////////
//    WinMerge:  an interactive diff/merge utility
//    Copyright (C) 1997-2000  Thingamahoochie Software
//    Author: Dean Grimm
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
/////////////////////////////////////////////////////////////////////////////
// EditFile.cpp : implementation file
//

#include "stdafx.h"
#include "merge.h"
#include "EditFile.h"
#include "coretools.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEditFile dialog


CEditFile::CEditFile(LPCTSTR szFilename, CMergeDoc *pdoc, CWnd* pParent /*=NULL*/)
	: CDialog(CEditFile::IDD, pParent)
{
	//{{AFX_DATA_INIT(CEditFile)
	m_strText = _T("");
	//}}AFX_DATA_INIT
	m_strFilename = szFilename;
	m_nStartLine=0;
	pd = pdoc;
}


void CEditFile::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEditFile)
	DDX_Control(pDX, IDC_FILE_EDIT, m_ctlText);
	DDX_Text(pDX, IDC_FILE_EDIT, m_strText);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CEditFile, CDialog)
	//{{AFX_MSG_MAP(CEditFile)
	ON_BN_CLICKED(IDC_COPY, OnCopy)
	ON_BN_CLICKED(IDC_CUT, OnCut)
	ON_BN_CLICKED(IDC_PASTE, OnPaste)
	ON_BN_CLICKED(IDC_UNDO, OnUndo)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEditFile message handlers

BOOL CEditFile::OnInitDialog() 
{
	CDialog::OnInitDialog();
	/*HANDLE hf;
	char buf[1025];

	if ((hf=FOPEN(m_strFilename)) != INVALID_HANDLE_VALUE)
	{
		DWORD dwRead;
		while (ReadFile(hf, buf, (sizeof buf)-1, &dwRead, NULL)
			&& dwRead > 0)
		{
			buf[dwRead] = NULL;
			m_strText += buf;
		}

		CloseHandle(hf);
	}*/
	UpdateData(FALSE);
	m_ctlText.SetLimitText(UINT_MAX);
	m_ctlText.LineScroll(m_nStartLine);

	m_ctlText.SetTabStops(8);

	CString s;
	AfxFormatString1(s, IDS_EDIT_WINDOW_TITLE_FMT, m_strFilename);
	SetWindowText(s);
	return TRUE;  
}

void CEditFile::OnCopy() 
{
	m_ctlText.Copy();
}

void CEditFile::OnCut() 
{
	m_ctlText.Cut();
}

void CEditFile::OnPaste() 
{
	m_ctlText.Paste();
}

void CEditFile::OnUndo() 
{
	m_ctlText.Undo();
}

BOOL CEditFile::DoSave()
{
	HANDLE hf;
	CString strSavePath(m_strFilename);

	// first, make a backup copy of the original
	CFileStatus status;

	if (!mf->CheckSavePath(strSavePath))
		return FALSE;

	if (!mf->CreateBackup(strSavePath))
		return FALSE;

	DeleteFile(strSavePath);
	if ((hf=FOPEN(strSavePath, GENERIC_WRITE, CREATE_ALWAYS)) != INVALID_HANDLE_VALUE)
	{
#define SAVEBUFSIZE    2048
		TCHAR buf[SAVEBUFSIZE];
		int size,cnt = m_ctlText.GetLineCount();
		for (int i=0; i < cnt; i++)
		{
			size = m_ctlText.GetLine(i, buf, SAVEBUFSIZE-1);
			buf[size] = NULL;
			_tcscat(buf, _T("\r\n"));
			//s = pd->Tabify(buf) + "\r\n";
			FPUTS(buf, hf);
		}
		CloseHandle(hf);
		return TRUE;
	}
	return FALSE;

}

void CEditFile::OnOK() 
{
	if (DoSave())
		CDialog::OnOK();
}
